
use strict;

use Time::HiRes;


package Lock;



# 引数 1	この時間以上古いロックは破棄します．
# 返り値  成功ならロックの情報を格納したハッシュへのリファレンス，失敗なら0
sub new
{
	my $now = Time::HiRes::time();

	my @chars = 'a' .. 'z';
	my $random = '';
	for ( 1..10 ) { $random .= $chars[ int( rand( @chars + 1 ) ) ]; }

	my %information;
	$information{'originalLockFile'} = 'lock';
	$information{'newLockFile'} = $information{'originalLockFile'} . $now . $random;

	#	ロックに成功すればロックファイル名を返す
	if ( rename( $information{'originalLockFile'} , $information{'originalLockFile'} ) )
	{
		return bless( \%information , $_[0] );
	}

	#	ディレクトリ検索
	opendir( DIRECTORY , './' );
	my @directory = readdir( DIRECTORY );
	closedir( DIRECTORY );

	# 現在のロックファイルを取得
	my $lockedTime = 0;
	my $oldLockFile;
	foreach ( @directory )
	{
		if ( $_ =~ /^${information{'originalLockFile'}}([0-9\.]+)/ )
		{
			$lockedTime += $1;
			$oldLockFile = $_;
			last;
		}
	}

	# ロックが期限切れなら上書き
	if (
		$lockedTime and
		$now - $lockedTime >= $_[1] and
		rename( $oldLockFile , $information{'newLockFile'} ) )
	{
		return bless( \%information , $_[0] );
	}

	return 0;
}



# ロックを解除します
sub DESTROY
{
	rename( $_[0]->{'newLockFile'} , $_[0]->{'originalLockFile'} );
}



1;
